---
title: 'Custom properties (--*): CSS variables'
slug: Web/CSS/--*
tags:
  - CSS
  - CSS Custom Properties
  - Guide
  - Reference
---
<div>{{CSSRef}}</div>

<p class="summary"><span class="seoSummary">Property names that are prefixed with <code>--</code>, like <code>--example-name</code>, represent <em>custom properties</em> that contain a value that can be used in other declarations using the {{cssxref("var")}} function.</span></p>

<p>Custom properties are scoped to the element(s) they are declared on, and participate in the cascade: the value of such a custom property is that from the declaration decided by the cascading algorithm.</p>

<p>{{CSSInfo}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">--somekeyword: left;
--somecolor: #0000ff;
--somecomplexvalue: 3px 6px rgb(20, 32, 54);
</pre>

<dl>
 <dt><code>&lt;declaration-value&gt;</code></dt>
 <dd>This value matches any sequence of one or more tokens, so long as the sequence does not contain an unallowed token. It represents the entirety of what a valid declaration can have as its value.</dd>
</dl>

<div class="notecard note">
<p><strong>Note</strong>: Custom property names are case sensitive — <code>--my-color</code> will be treated as a separate custom property to <code>--My-color</code>.</p>
</div>

<h3 id="Formal_syntax">Formal syntax</h3>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Example">Example</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;p id="firstParagraph"&gt;This paragraph should have a blue background and yellow text.&lt;/p&gt;
&lt;p id="secondParagraph"&gt;This paragraph should have a yellow background and blue text.&lt;/p&gt;
&lt;div id="container"&gt;
  &lt;p id="thirdParagraph"&gt;This paragraph should have a green background and yellow text.&lt;/p&gt;
&lt;/div&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">:root {
  --first-color: #16f;
  --second-color: #ff7;
}

#firstParagraph {
  background-color: var(--first-color);
  color: var(--second-color);
}

#secondParagraph {
  background-color: var(--second-color);
  color: var(--first-color);
}

#container {
  --first-color: #290;
}

#thirdParagraph {
  background-color: var(--first-color);
  color: var(--second-color);
}</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example', 500, 130)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS3 Variables", "#defining-variables", "--*")}}</td>
   <td>{{Spec2("CSS3 Variables")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.custom-property")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/Using_CSS_variables">Using CSS variables</a></li>
 <li><span class="seoSummary">The {{cssxref("var")}} function</span></li>
</ul>
